// stablo_t.c - Ispitivanje paketa za obradu binarnih stabala.

#include "stablo.h"
#include <stdio.h>
#include <ctype.h>

_Bool moze(Stablo stb) { // Da li može uređena radnja?
  if (uredjeno(stb)) return 1;
  printf("*** Stablo nije uredjeno! ***\a\n");
  return 0;
}

// Primena operacije na stablo za svaki pročitani broj:
Stablo radi(Stablo (*f)(Stablo,int), Stablo stb) {
  int b; printf("Brojevi?   ");
  char zn;
  do { scanf("%d%c", &b, &zn); stb = (*f)(stb, b); } while (zn != '\n');
  return stb;                                        // do kraja reda
}

int main() {
  Stablo stb = stvori(); _Bool kraj = 0; int n, broj;
  while (!kraj) {
    printf("\nDodavanje brojeva:       a) uredjeno     b) neuredjeno\n"
             "Izostavljanje brojeva:   c) uredjeno     d) neuredjeno\n"
             "Citanje stabla:          e) uredjeno     f) neuredjeno\n"
             "Najmanji element:        g) uredjeno     h) neuredjeno\n"
             "Najveci element:         i) uredjeno     j) neuredjeno\n"
             "Pretrazivanje:           k) uredjeno     l) neuredjeno\n"
             "Balansiranje:            m) uredjeno     n) neuredjeno\n"
             "Pisanje stabla:          p) koren-levo-desno\n"
             "                         q) levo-koren-desno\n"
             "                         r) levo-desno-koren\n"
             "                         s) crtanje\n"
             "1. Velicina stabla       2. Zbir elemenata\n"
             "3. Broj pojavljivanja    4. Praznjenje stabla\n"
             "                         0. Zavrsetak rada\n\n"
             "Vas izbor? "
           );
 
    char izbor[2]; scanf("%s", &izbor); char izb = toupper(izbor[0]);
    switch (izb) {
    case 'A':     // Dodavanje brojeva u uređeno stablo:
      if (moze(stb)) stb = radi(dodaj_u, stb); break;
    case 'B':     // Dodavanje brojeva u neuređeno stablo:
                     stb = radi(dodaj_n, stb); break;
    case 'C':     // Izostavljanje brojeva iz uređenog stabla:
      if (moze(stb)) stb = radi(izost_u, stb); break;
    case 'D':     // Izostavljanje brojeva iz neuređenog stabla:
                     stb = radi(izost_n, stb); break;
    case 'E':     // Čitanje uređenog stabla:
      printf("Duzina?    "); scanf("%d", &n);
      printf("Brojevi?   "); stb = brisi(stb); stb = citaj_u(n);
      break;
    case 'F':     // Čitanje neuređenog stabla:
      printf("Duzina?    "); scanf("%d", &n);
      printf("Brojevi?   "); stb = brisi(stb); stb = citaj_n(n);
      break;
    case 'G': case 'H': case 'I': case 'J':
      if (stb) 
        switch(izb) {
        case 'G': // Najmanji element uređenog stabla:
          if (moze(stb)) printf("min=       %d\n", min_u(stb)); break;
        case 'H': // Najmanji element neuređenog stabla:
                         printf("min=       %d\n", min_n(stb)); break;
        case 'I': // Najveći element uređenog stabla:
          if (moze(stb)) printf("max=       %d\n", max_u(stb)); break;
        case 'J': // Najveći element neuređenog stabla:
                         printf("max=       %d\n", max_n(stb)); break;
      } else printf("*** Stablo je prazno! ***\a\n");
      break;
    case 'K':     // Broj pojavljivanja u uređenom stablu:
      if (moze(stb)) {
        printf("Broj?      "); scanf("%d", &broj);
        printf("Broj se%s nalazi u stablu.\n",
               (nadji_u(stb, broj) != NULL ? "" : " NE"));
      } break;
    case 'L':     // Broj pojavljivanja u neuređenom stablu:
        printf("Broj?      "); scanf("%d", &broj);
        printf("Broj se%s nalazi u stablu.\n",
               (nadji_n(stb, broj) != NULL ? "" : " NE"));
        break;
    case 'M':     // Balansiranje uređenog stabla:
      if (moze(stb)) stb = balans_u(stb); break;
    case 'N':     // Balansiranje neuređenog stabla:
                     stb = balans_n(stb); break;
    case 'P':     // Pisanje stabla koren-levo-desno:
      printf("Stablo=    "); pisi_kld(stb); putchar('\n'); break;
    case 'Q':     // Pisanje stabla levo-koren-desno:
      printf("Stablo=    "); pisi_lkd(stb); putchar('\n'); break;
    case 'R':     // Pisanje stabla levo-desno-koren:
      printf("Stablo=    "); pisi_ldk(stb); putchar('\n'); break;
    case 'S':     // Crtanje stabla:
      crtaj(stb, 0); break;
    case '1':     // Veličina stabla:
      printf("Vel=       %d\n", vel(stb)); break;
    case '2':     // Zbir elemenata stabla:
      printf("Zbir=      %d\n", zbir(stb)); break;
     case '3':     // Broj pojavljivanja datog broja:
      printf("Broj?      "); scanf("%d", &broj);
      printf("Broj se pojavljuje %d puta.\n", pojav(stb, broj));
      break;
    case '4':     // Pražnjenje stabla:
      stb = brisi(stb); break;
    case '0':     // Završetak rada:
      kraj = 1; break;
    default:      // Pogrešan izbor:
      printf("*** Nedozvoljen izbor! ***\a\n"); break;
    }
  }
}
